Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
DL_PrivateKey_EC< EC > Class Template Reference

Elliptic Curve Discrete Log (DL) private key. More...

Inheritance diagram for DL_PrivateKey_EC< EC >:

## Public Types
typedef EC::Point | Element
Public Types inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
typedef GP::Element | Element
Public Types inherited from DL_PrivateKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< PK, GP, O >
typedef GP | GroupParameters

## Public Member Functions
void | Initialize (const DL_GroupParameters_EC< EC > &params, const Integer &x)
| Initialize an EC Private Key using {GP,x}. More...
void | Initialize (const EC &ec, const Element &G, const Integer &n, const Integer &x)
| Initialize an EC Private Key using {EC,G,n,x}. More...
void | Initialize (RandomNumberGenerator &rng, const DL_GroupParameters_EC< EC > &params)
| Create an EC private key. More...
void | Initialize (RandomNumberGenerator &rng, const EC &ec, const Element &G, const Integer &n)
| Create an EC private key. More...
void | BERDecodePrivateKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
void | DEREncodePrivateKey (BufferedTransformation &bt) const
Public Member Functions inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters. More...
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters. More...
const Integer & | GetPrivateExponent () const
| Retrieves the private exponent. More...
void | SetPrivateExponent (const Integer &x)
| Sets the private exponent. More...
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| Decode privateKey part of privateKeyInfo. More...
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo. More...
Public Member Functions inherited from DL_PrivateKey< GP::Element >
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
| Initializes a public key from this key. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key. More...
Public Member Functions inherited from DL_KeyImpl< PK, GP, O >
O | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()

## Detailed Description

### template<class EC>
class DL_PrivateKey_EC< EC >

Elliptic Curve Discrete Log (DL) private key.

Template Parameters

  EC | elliptic curve field

Definition at line 209 of file eccrypto.h.

## Member Function Documentation

## ◆ Initialize() [1/4]

template<class EC >

void DL_PrivateKey_EC< EC >::Initialize | ( | const DL_GroupParameters_EC< EC > & | params,
|  | const Integer & | x
| ) |  |
| inline

Initialize an EC Private Key using {GP,x}.

Parameters

  params | group parameters
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 220 of file eccrypto.h.

## ◆ Initialize() [2/4]

template<class EC >

void DL_PrivateKey_EC< EC >::Initialize | ( | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n,
|  | const Integer & | x
| ) |  |
| inline

Initialize an EC Private Key using {EC,G,n,x}.

Parameters

  ec | the elliptic curve
  G | the base point
  n | the order of the base point
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 229 of file eccrypto.h.

## ◆ Initialize() [3/4]

template<class EC >

void DL_PrivateKey_EC< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const DL_GroupParameters_EC< EC > & | params
| ) |  |
| inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  params | the EC group parameters

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 238 of file eccrypto.h.

## ◆ Initialize() [4/4]

template<class EC >

void DL_PrivateKey_EC< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n
| ) |  |
| inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  ec | the elliptic curve
  G | the base point
  n | the order of the base point

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 249 of file eccrypto.h.

The documentation for this class was generated from the following file:

- eccrypto.h